package bgs.com.pruebasservicios;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "bgs.com.pruebasservicios", "bgs.com.pruebasservicios.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "bgs.com.pruebasservicios", "bgs.com.pruebasservicios.main");
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button1 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button2 = null;
public static int _horamarcha = 0;
public static int _minutomarcha = 0;
public anywheresoftware.b4a.objects.collections.List _list1 = null;
public bgs.com.pruebasservicios.serviciopruebas _serviciopruebas = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 33;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 36;BA.debugLine="Button1.Initialize(\"Button1\")";
mostCurrent._button1.Initialize(mostCurrent.activityBA,"Button1");
 //BA.debugLineNum = 37;BA.debugLine="Button1.Text=\"ON\"";
mostCurrent._button1.setText((Object)("ON"));
 //BA.debugLineNum = 38;BA.debugLine="Activity.AddView(Button1,35%x,5%y,150dip,100dip)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._button1.getObject()),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(35),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(5),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(150)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(100)));
 //BA.debugLineNum = 40;BA.debugLine="Button2.Initialize(\"Button2\")";
mostCurrent._button2.Initialize(mostCurrent.activityBA,"Button2");
 //BA.debugLineNum = 41;BA.debugLine="Button2.Text=\"OFF\"";
mostCurrent._button2.setText((Object)("OFF"));
 //BA.debugLineNum = 42;BA.debugLine="Activity.AddView(Button2,35%x,50%y,150dip,100dip)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._button2.getObject()),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(35),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(50),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(150)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(100)));
 //BA.debugLineNum = 44;BA.debugLine="List1.Initialize";
mostCurrent._list1.Initialize();
 //BA.debugLineNum = 45;BA.debugLine="List1.Add(0)";
mostCurrent._list1.Add((Object)(0));
 //BA.debugLineNum = 46;BA.debugLine="List1.Add(1)";
mostCurrent._list1.Add((Object)(1));
 //BA.debugLineNum = 50;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 56;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 58;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 52;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 54;BA.debugLine="End Sub";
return "";
}
public static String  _button1_click() throws Exception{
anywheresoftware.b4a.agraham.dialogs.InputDialog.TimeDialog _td = null;
int _alarmhours = 0;
int _alarmminutes = 0;
long _today = 0L;
long _alarm = 0L;
int _h = 0;
int _m = 0;
 //BA.debugLineNum = 60;BA.debugLine="Sub Button1_Click";
 //BA.debugLineNum = 62;BA.debugLine="Dim td As TimeDialog";
_td = new anywheresoftware.b4a.agraham.dialogs.InputDialog.TimeDialog();
 //BA.debugLineNum = 63;BA.debugLine="Dim alarmHours, alarmMinutes As Int";
_alarmhours = 0;
_alarmminutes = 0;
 //BA.debugLineNum = 65;BA.debugLine="td.Hour = alarmHours";
_td.setHour(_alarmhours);
 //BA.debugLineNum = 66;BA.debugLine="td.Minute = alarmMinutes";
_td.setMinute(_alarmminutes);
 //BA.debugLineNum = 68;BA.debugLine="If td.Show(\"Select time\", \"\", \"Ok\", \"Cancel\", \"\", Null) = DialogResponse.POSITIVE Then";
if (_td.Show("Select time","","Ok","Cancel","",mostCurrent.activityBA,(android.graphics.Bitmap)(anywheresoftware.b4a.keywords.Common.Null))==anywheresoftware.b4a.keywords.Common.DialogResponse.POSITIVE) { 
 //BA.debugLineNum = 69;BA.debugLine="alarmHours = td.Hour";
_alarmhours = _td.getHour();
 //BA.debugLineNum = 70;BA.debugLine="alarmMinutes = td.Minute";
_alarmminutes = _td.getMinute();
 //BA.debugLineNum = 71;BA.debugLine="HoraMarcha = alarmHours";
_horamarcha = _alarmhours;
 //BA.debugLineNum = 72;BA.debugLine="MinutoMarcha = alarmMinutes";
_minutomarcha = _alarmminutes;
 //BA.debugLineNum = 73;BA.debugLine="GraboFile";
_grabofile();
 //BA.debugLineNum = 75;BA.debugLine="Log(\"alarm Hours \" & alarmHours & \" alarm Minutes \" & alarmMinutes)";
anywheresoftware.b4a.keywords.Common.Log("alarm Hours "+BA.NumberToString(_alarmhours)+" alarm Minutes "+BA.NumberToString(_alarmminutes));
 //BA.debugLineNum = 77;BA.debugLine="Dim today, alarm As Long";
_today = 0L;
_alarm = 0L;
 //BA.debugLineNum = 78;BA.debugLine="today = DateTime.DateParse(DateTime.Date(DateTime.Now)) 'Sets today at 12:00 AM";
_today = anywheresoftware.b4a.keywords.Common.DateTime.DateParse(anywheresoftware.b4a.keywords.Common.DateTime.Date(anywheresoftware.b4a.keywords.Common.DateTime.getNow()));
 //BA.debugLineNum = 79;BA.debugLine="alarm = today + td.Hour * DateTime.TicksPerHour + td.Minute * DateTime.TicksPerMinute";
_alarm = (long)(_today+_td.getHour()*anywheresoftware.b4a.keywords.Common.DateTime.TicksPerHour+_td.getMinute()*anywheresoftware.b4a.keywords.Common.DateTime.TicksPerMinute);
 //BA.debugLineNum = 80;BA.debugLine="Log(\"today \" & today)";
anywheresoftware.b4a.keywords.Common.Log("today "+BA.NumberToString(_today));
 //BA.debugLineNum = 81;BA.debugLine="Log(\"alarm \" & alarm)";
anywheresoftware.b4a.keywords.Common.Log("alarm "+BA.NumberToString(_alarm));
 //BA.debugLineNum = 82;BA.debugLine="If alarm < DateTime.Now Then";
if (_alarm<anywheresoftware.b4a.keywords.Common.DateTime.getNow()) { 
 //BA.debugLineNum = 83;BA.debugLine="alarm = DateTime.Add(alarm, 0, 0, 1)";
_alarm = anywheresoftware.b4a.keywords.Common.DateTime.Add(_alarm,(int)(0),(int)(0),(int)(1));
 //BA.debugLineNum = 84;BA.debugLine="Log(\"alarm < hora actual \" & alarm)";
anywheresoftware.b4a.keywords.Common.Log("alarm < hora actual "+BA.NumberToString(_alarm));
 };
 //BA.debugLineNum = 87;BA.debugLine="Log(\"alarm- today \" & (alarm - today))";
anywheresoftware.b4a.keywords.Common.Log("alarm- today "+BA.NumberToString((_alarm-_today)));
 //BA.debugLineNum = 89;BA.debugLine="Log(\"Fecha hora alarma \" & DateTime.Date(alarm) & \" \" & DateTime.Time(alarm)) 'check the logs to see the set date and time";
anywheresoftware.b4a.keywords.Common.Log("Fecha hora alarma "+anywheresoftware.b4a.keywords.Common.DateTime.Date(_alarm)+" "+anywheresoftware.b4a.keywords.Common.DateTime.Time(_alarm));
 //BA.debugLineNum = 92;BA.debugLine="Dim h, m As Int";
_h = 0;
_m = 0;
 //BA.debugLineNum = 93;BA.debugLine="h = Floor((alarm - DateTime.Now) / DateTime.TicksPerHour)";
_h = (int)(anywheresoftware.b4a.keywords.Common.Floor((_alarm-anywheresoftware.b4a.keywords.Common.DateTime.getNow())/(double)anywheresoftware.b4a.keywords.Common.DateTime.TicksPerHour));
 //BA.debugLineNum = 94;BA.debugLine="m = ((alarm - DateTime.Now) - h * DateTime.TicksPerHour) / DateTime.TicksPerMinute";
_m = (int)(((_alarm-anywheresoftware.b4a.keywords.Common.DateTime.getNow())-_h*anywheresoftware.b4a.keywords.Common.DateTime.TicksPerHour)/(double)anywheresoftware.b4a.keywords.Common.DateTime.TicksPerMinute);
 //BA.debugLineNum = 95;BA.debugLine="Msgbox(\"Time to alarm: \" & NumberFormat(h, 2, 0) & \":\" & NumberFormat(m, 2, 0) ,\"\")";
anywheresoftware.b4a.keywords.Common.Msgbox("Time to alarm: "+anywheresoftware.b4a.keywords.Common.NumberFormat(_h,(int)(2),(int)(0))+":"+anywheresoftware.b4a.keywords.Common.NumberFormat(_m,(int)(2),(int)(0)),"",mostCurrent.activityBA);
 //BA.debugLineNum = 96;BA.debugLine="Log(\"NextTime in Main \" & alarm)";
anywheresoftware.b4a.keywords.Common.Log("NextTime in Main "+BA.NumberToString(_alarm));
 //BA.debugLineNum = 97;BA.debugLine="StartService(ServicioPruebas)";
anywheresoftware.b4a.keywords.Common.StartService(mostCurrent.activityBA,(Object)(mostCurrent._serviciopruebas.getObject()));
 //BA.debugLineNum = 98;BA.debugLine="ExitApplication";
anywheresoftware.b4a.keywords.Common.ExitApplication();
 };
 //BA.debugLineNum = 102;BA.debugLine="End Sub";
return "";
}
public static String  _button2_click() throws Exception{
 //BA.debugLineNum = 104;BA.debugLine="Sub Button2_Click";
 //BA.debugLineNum = 106;BA.debugLine="CancelScheduledService(ServicioPruebas)";
anywheresoftware.b4a.keywords.Common.CancelScheduledService(mostCurrent.activityBA,(Object)(mostCurrent._serviciopruebas.getObject()));
 //BA.debugLineNum = 107;BA.debugLine="StopService(ServicioPruebas)";
anywheresoftware.b4a.keywords.Common.StopService(mostCurrent.activityBA,(Object)(mostCurrent._serviciopruebas.getObject()));
 //BA.debugLineNum = 109;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        main._process_globals();
serviciopruebas._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 22;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 25;BA.debugLine="Dim Button1 As Button";
mostCurrent._button1 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 26;BA.debugLine="Dim Button2 As Button";
mostCurrent._button2 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 27;BA.debugLine="Dim HoraMarcha As Int";
_horamarcha = 0;
 //BA.debugLineNum = 28;BA.debugLine="Dim MinutoMarcha As Int";
_minutomarcha = 0;
 //BA.debugLineNum = 29;BA.debugLine="Dim List1 As List";
mostCurrent._list1 = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 31;BA.debugLine="End Sub";
return "";
}
public static String  _grabofile() throws Exception{
 //BA.debugLineNum = 112;BA.debugLine="Sub GraboFile()";
 //BA.debugLineNum = 114;BA.debugLine="List1.Clear";
mostCurrent._list1.Clear();
 //BA.debugLineNum = 115;BA.debugLine="List1.Add(HoraMarcha)";
mostCurrent._list1.Add((Object)(_horamarcha));
 //BA.debugLineNum = 116;BA.debugLine="List1.Add(MinutoMarcha)";
mostCurrent._list1.Add((Object)(_minutomarcha));
 //BA.debugLineNum = 118;BA.debugLine="Try";
try { //BA.debugLineNum = 119;BA.debugLine="File.WriteList(File.DirDefaultExternal,\"BGSPruebasServicios.dat\", List1)";
anywheresoftware.b4a.keywords.Common.File.WriteList(anywheresoftware.b4a.keywords.Common.File.getDirDefaultExternal(),"BGSPruebasServicios.dat",mostCurrent._list1);
 } 
       catch (Exception e67) {
			processBA.setLastException(e67); //BA.debugLineNum = 121;BA.debugLine="Log(\"Servicio: Error al escribir fichero BGSPruebasServicios.dat\")";
anywheresoftware.b4a.keywords.Common.Log("Servicio: Error al escribir fichero BGSPruebasServicios.dat");
 };
 //BA.debugLineNum = 125;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 20;BA.debugLine="End Sub";
return "";
}
}
