﻿Type=Service
Version=2.71
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim Flag_ON As Boolean
	Dim NextTime As Long
	Dim HoraMarcha As Int
	Dim MinutoMarcha As Int
  Dim List1 As List

	
End Sub
Sub Service_Create
  
	GrabarTraza ("----- Service_Create ------")
	GrabarTraza ("Flag_ON before giving value " & Flag_ON)
	GrabarTraza ("NextTime before giving value " & NextTime)
	List1.Initialize
  List1.Add(0)
	List1.Add(1)
	
	
	
	
End Sub

Sub Service_Start (StartingIntent As Intent)

  GrabarTraza ("----- Service_Start IN -----")
	
	If Flag_ON = False Then
	  LeoFile			
  	NextTime=CalcularTickEntreDosHoras (HoraMarcha, MinutoMarcha)  
		GrabarTraza ("Time To alarm: " & NumberFormat(HoraMarcha,2,0) & ":" & NumberFormat(MinutoMarcha,2,0))
	End If	
	
	GrabarTraza ("NextTime in Ticks " & NextTime  )
	GrabarTraza ("NextTime " & DateTime.Date(NextTime) & " - " & DateTime.Time(NextTime))
	
	If DateTime.now>= NextTime Then
	  GrabarTraza ("Time to alarm END")
	 	ToastMessageShow("Time to alarm END" ,True)
		Return
	End If
	
	Flag_ON =True
	GrabarTraza ("Flag_ON " & Flag_ON )
	
	GrabarTraza ("----- Service_Start OUT ----- & CRLF")
	
	StartServiceAt("", NextTime, True)
	
End Sub

Sub Service_Destroy

    GrabarTraza ("********** Service_Destroy *********")
	  GrabarTraza ("Flag_ON " & Flag_ON)
	  GrabarTraza ("NextTime " & NextTime)
	
End Sub


Sub GrabarTraza (Texto As String)
Dim DirFile As String
Dim T_F As String



Log("Traza " & Texto)

If File.Exists(File.DirDefaultExternal, "TrazaBGS.txt") Then
  T_F=File.GetText(File.DirDefaultExternal, "TrazaBGS.txt")	  
End If

T_F= T_F & DateTime.Date(DateTime.Now) & " - " & DateTime.Time(DateTime.Now) & " " & Texto & CRLF 

Try
  File.WriteString (File.DirDefaultExternal,"TrazaBGS.txt", T_F)
Catch
  Log("Error al grabar fichero TrazaBGS.txt")
End Try



End Sub


Sub LeoFile()

  If File.Exists(File.DirDefaultExternal, "BGSPruebasServicios.dat") Then
	  List1 = File.ReadList(File.DirDefaultExternal, "BGSPruebasServicios.dat")
    HoraMarcha = List1.Get(0)
		MinutoMarcha = List1.Get(1)
	End If
	
	
End Sub

Sub CalcularTickEntreDosHoras (hora As Int, minuto As Int)
	' calcular tick entre hora actual y hora/minutos pasados
    Dim today, alarm As Long
		
		
    today = DateTime.DateParse(DateTime.Date(DateTime.Now)) 'Sets today at 12:00 AM
		
		alarm = today + hora * DateTime.TicksPerHour + minuto * DateTime.TicksPerMinute
		
    If alarm < DateTime.Now Then
		    alarm = DateTime.Add(alarm, 0, 0, 1)
		End If	
	
	
	  If alarm < DateTime.Now Then alarm = DateTime.Now + 1 * DateTime.TicksPerMinute	 
	
    Return alarm



End Sub
